;//**   File: gstrtoint.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat
option casemap: none

		
.code

;=======================================
;   int stdcall gStrToInt (char* str) 
;=======================================
gStrToInt equ _gStrToInt@4
gStrToInt proc
	;/------------------------------------------------------------------------------------------------------\
	;| The func is for string to int conversions.                                                           |
	;| Example gStrToInt("-123") the output is 0xFFFFFF85 (-123).                                           |
	;| Limitations: The func don't have any error cheking at ALL (more optimized), so put correct strings!! |
	;\------------------------------------------------------------------------------------------------------/
	add esp, 0FFFFFFFFh             ;char bSign = 0;   //a flag for the sign                 
	push ebx                        ;ebx is the returned int
	push esi                        ;pointer to the str
	
	cld
	
	mov esi, dword ptr [esp+0Dh]
	xor ebx, ebx
	xor eax, eax
	
	;-------------------------------------------------
	;if the string has '-' ("-123") then set the bSign
	;-------------------------------------------------
	lodsb
	.if al == '-'
		mov byte ptr [esp+08h], 01h   ;set the flag
		lodsb
	.elseif al == '+'
		mov byte ptr [esp+08h], 00h   ;set the flag
		lodsb
	.else
		mov byte ptr [esp+08h], 00h   ;set the flags
	.endif
	

	;--------
	;the loop
	;--------
	@@:
		sub al, '0'
		
		imul ebx, 0Ah
		add ebx, eax
	
		lodsb 
	test al, al
	jne @B	
	

	;-------------------------------------------
	;Make the ebx negative if the string has '-'
	;-------------------------------------------	
	mov al, byte ptr [esp+08h]
	test al, al
	je @F
		neg ebx
	@@:
	
	mov eax, ebx
	
	pop esi
	pop ebx 
	add esp, 01h
	ret 04h
gStrToInt endp
	

	
end