;//**   File: ginttostrhex.asm
;//**
;//**   Created by GODlike (www.ancientritual.tk)

.686
.model flat, stdcall
option casemap: none

gStrcpy proto :dword, :dword
		
.code

;=======================================================
;   void stdcall gIntToStrHex (char* pcDest, int num)
;=======================================================
OPTION EPILOGUE:NONE
gIntToStrHex proc pcDest:dword, num:dword
	;/----------------------------------------------------------------\
	;| Converts an int (32bit) to string in hexademical display       |
	;| Optimized for speed                                            |
	;| Example gIntToStrHex(0x12345678) returns the "12345678" string |
	;| Warning the pcDest points to a 9 byte array (max)              |
	;| Returns the bytes written minus one                            |
	;\----------------------------------------------------------------/
	local pcTmp[9]:byte       ;a temp str
	push edi                  ;pointer to char
	push ebx                  ;the num
	
	
	lea edi, [pcTmp+7]        ;edi = pcDest
	mov byte ptr [edi+1], 00h ;finalize str
	mov ebx, [num]            ;ebx = num
	
	;---------------------
	;loop to build the str 
	;---------------------
	@@:
		xor al, al
		mov ah, bl
		and ah, 0Fh
	
		cmp ah, 09h              ;al = (ah>9) ? ('A'-0Ah) : ('0')  //without brunch
		seta al
		sub al, 01h
		and al, '0' - ('A'-0Ah)
		add al, ('A'-0Ah)
	
		add al, ah
	
		mov byte ptr [edi], al
		shr ebx, 4
		dec edi

	test ebx, ebx
	jne @B

	;--------------------
	;copy pcTmp to pcDest
	;--------------------
	inc edi
	invoke gStrcpy, pcDest, edi
	
	pop ebx
	pop edi
	mov esp, ebp
	pop ebp
	;leave
	ret 08h
gIntToStrHex endp
OPTION EPILOGUE:EpilogueDef
	
	
end